slow_forum/urls.py
from django.urls import path

from . import views
from . import feeds


app_name = 'slow_forum'


urlpatterns = [
    # Views
    path('', views.IndexView.as_view(), name='index'),
    path(
        'topic/add/',
        views.TopicCreateView.as_view(),
        name='topic-add',
    ),
    path(
        'topic/add/in_category/<int:topic_category_pk>/',
        views.TopicCreateView.as_view(),
        name='topic-add-in-category',
    ),
    path(
        'topic/<int:pk>/',
        views.TopicDetailView.as_view(),
        name='topic-detail',
    ),
    path(
        'topic/<int:pk>/edit/',
        views.TopicUpdateView.as_view(),
        name='topic-update',
    ),
    path(
        'topic/<int:pk>/delete/',
        views.TopicDeleteView.as_view(),
        name='topic-delete',
    ),
    path(
        'topic/<int:topic_pk>/add_reply/',
        views.TopicReplyCreateView.as_view(),
        name='topic-reply-add',
    ),
    path(
        'topic/<int:topic_pk>/reply/<int:pk>/edit/',
        views.TopicReplyUpdateView.as_view(),
        name='topic-reply-update',
    ),
    path(
        'categories/',
        views.TopicCategoryListView.as_view(),
        name='topic-category-list',
    ),
    path(
        'categories/add/',
        views.TopicCategoryCreateView.as_view(),
        name='topic-category-add',
    ),
    path(
        'categories/<int:pk>/',
        views.TopicCategoryDetailView.as_view(),
        name='topic-category-details',
    ),
    path(
        'categories/<int:pk>/edit/',
        views.TopicCategoryUpdateView.as_view(),
        name='topic-category-update',
    ),
    path(
        'categories/<int:pk>/delete/',
        views.TopicCategoryDeleteView.as_view(),
        name='topic-category-delete',
    ),
    path(
        'topic/<int:topic_pk>/reply/<int:pk>/delete/',
        views.TopicReplyDeleteView.as_view(),
        name='topic-reply-delete',
    ),
    path(
        'user_profiles/',
        views.UserProfileListView.as_view(),
        name='user-profile-list',
    ),
    path(
        'user_profiles/<int:pk>/',
        views.UserProfileDetailView.as_view(),
        name='user-profile-detail',
    ),
    path(
        'user_profiles/<int:pk>/topics/tab/<str:tab_name>/',
        views.UserProfileDetailView.as_view(),
        name='user-profile-detail-tab',
    ),
    path(
        'user_profiles/<int:pk>/edit/',
        views.UserProfileUpdateView.as_view(),
        name='user-profile-edit-profile',
    ),
    path(
        'about/',
        views.AboutView.as_view(),
        name='about',
    ),
    # Feeds
    path(
        'feeds/',
        views.FeedsView.as_view(),
        name='feeds',
    ),
    path(
        'feeds/topics/all/',
        feeds.TopicsAllFeed(),
        name='feed-topics-all',
    ),
    path(
        'feeds/topic_replies/all/',
        feeds.TopicRepliesAllFeed(),
        name='feed-topic-replies-all',
    ),
    path(
        'feeds/topics/category/<int:category_pk>/',
        feeds.TopicsCategoryFeed(),
        name='feed-topics-category',
    ),
    path(
        'feeds/topics_replies/category/<int:category_pk>/',
        feeds.TopicRepliesCategoryFeed(),
        name='feed-topic-replies-category',
    ),
    path(
        'feeds/topics_replies/topic/<int:topic_pk>/',
        feeds.TopicRepliesTopicFeed(),
        name='feed-topic-replies-topic',
    ),
    path(
        'search/',
        views.SearchView.as_view(),
        name='search',
    ),
    path(
        'search/topics/',
        views.SearchView.as_view(search_type='topic'),
        name='search-topics',
    ),
]

slow_forum_site/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path


from slow_forum_registration import views as forum_regist_views

urlpatterns = [
    path('', include('slow_forum.urls')),
    path('admin/', admin.site.urls),
    path(
        'accounts/register/',
        forum_regist_views.CustomRegistrationView.as_view(),
        name='django_registration_register',
    ),
    path('accounts/', include('django_registration.backends.activation.urls')),
    path('accounts/', include('django.contrib.auth.urls')),
]

if settings.DEBUG:
    urlpatterns += static(
        settings.MEDIA_URL,
        document_root=settings.MEDIA_ROOT,
    )

slow_forum/models.py
from django.db import models
from django.conf import settings
from django.utils import timezone
from django.utils.translation import gettext_lazy as _
from django.conf import settings
from django.urls import reverse
from django.core.validators import (
    EmailValidator,
    URLValidator,
)

from .convert import markdown_to_html

EXTERNAL_LINK_ALLOWED_SCHEMES = (
    'https',
    'xmpp',
    'matrix',
    'ircs',
    'irc',
    'mailto',
)


# Abstract models

class EditableModel(models.Model):
    """An editable Model"""
    edited = models.BooleanField(
        default=False,
        verbose_name=_('edited'),
    )
    edited_by = models.ForeignKey(
        settings.AUTH_USER_MODEL,
        on_delete=models.CASCADE,
        related_name='+',
        blank=True,
        null=True,
        verbose_name=_('edited_by'),
    )
    edited_on = models.DateTimeField(
        blank=True,
        null=True,
        verbose_name=_('edited_on'),
    )

    class Meta:
        abstract = True

    def record_edition(self, by_user, on_datetime):
        """Recorde an edition by a user"""
        self.edited = True
        self.edited_by = by_user
        self.edited_on = on_datetime


class FormatedMessage(models.Model):
    """A Message formated with Markdown"""
    message = models.TextField(
        verbose_name=_('message'),
        help_text=_('You can use Markdown')
    )
    message_html = models.TextField(
        blank=True,
        null=True,
        verbose_name=_('message_html'),
        help_text=_(
            'HTML version of the message, automatically generated on save'
        ),
    )

    class Meta:
        abstract = True

    def generate_message_html(self):
        """Generate message_html field by convert message field"""
        self.message_html = markdown_to_html(self.message)

    def save(self, *args, **kwargs):
        """Override save method"""
        # Generate the html version of the message
        self.generate_message_html()
        return super(FormatedMessage, self).save(*args, **kwargs)


# Models

class UserProfile(EditableModel):
    """A user profile, linked to a User account"""
    user = models.OneToOneField(
        settings.AUTH_USER_MODEL,
        on_delete=models.CASCADE,
        related_name='profile',
        verbose_name=_('user'),
    )
    nickname = models.CharField(
        max_length=255,
        null=True,
        unique=True,
        verbose_name=_('nickname'),
    )
    abstract = models.TextField(
        null=True,
        blank=True,
        verbose_name=_('abstract'),
    )

    class Meta:
        ordering = ('nickname',)
        verbose_name = _('User profile')
        verbose_name_plural = _('User profiles')
        permissions = [
            (
                'view_user_profile_edition_infos',
                _('Can view user profile infos related to edition'),
            ),
        ]

    def __str__(self):
        return self.nickname or 'Nickname not defined'

    def get_absolute_url(self):
        """Get the absolute URL of an instance"""
        return reverse(
            'slow_forum:user-profile-detail',
            kwargs={'pk': self.pk},
        )

    def latest_topic_set(self, count=5):
        """Get the latest topics

        Property:
        * count (int): How many latest topic in max

        Return:
        (queryset): The latest topics
        """
        return self.user.topic_set.order_by(
            '-created_on',
        ).order_by(
            '-pk',
        )[:count]

    def latest_topicreply_set(self, count=5):
        """Get the latest topics

        Property:
        * count (int): How many latest topic in max

        Return:
        (queryset): The latest topics
        """
        return self.user.topicreply_set.order_by(
            '-created_on',
        ).order_by(
            '-pk',
        )[:count]
    
    @classmethod
    def create_missing(cls, user_queryset):
        """Create the missing profiles for Users

        Parameter:
        * user_queryset: The User queryset on which create profile

        Return:
        * (int): The number of user for which a profile has been created
        """
        # Filter queryset, to be sure we only have users with no profiles
        filtered_user_queryset = user_queryset.filter(profile__isnull=True)

        # Check we still have Users
        if len(filtered_user_queryset) == 0:
            return 0

        # If still Users
        for user in filtered_user_queryset:
            cls.objects.create(user=user)

        # Return how many users was missing profiles
        return len(filtered_user_queryset)


class UserProfileExternalLinks(models.Model):
    """An extrenal link, related to a profile"""
    user_profile = models.ForeignKey(
        UserProfile,
        on_delete=models.CASCADE,
        related_name='external_link_set',
        verbose_name=_('user profile'),
    )
    priority = models.IntegerField(
        default=0,
        verbose_name=_('priority'),
    )
    label = models.CharField(
        max_length=255,
        verbose_name=_('label'),
    )
    url = models.URLField(
        max_length=200,
        validators=(
            URLValidator(schemes=EXTERNAL_LINK_ALLOWED_SCHEMES),
        ),
        verbose_name=_('URL'),
    )

    class Meta:
        ordering = ('priority',)
        verbose_name = _('User profile extrenal link')
        verbose_name_plural = _('User profile extrenal links')

    def __str__(self):
        """Get the str version"""
        return f'{self.label}'

    def get_absolute_url(self):
        """Get the absolute URL of an instance"""
        return self.user_profile.get_absolute_url()


class TopicCategory(EditableModel):
    """A topics category"""
    created_by = models.ForeignKey(
        settings.AUTH_USER_MODEL,
        on_delete=models.CASCADE,
        verbose_name=_('created_by'),
    )
    created_on = models.DateTimeField(
        default=timezone.now,
        verbose_name=_('created_on'),
    )
    title = models.CharField(
        max_length=255,
        unique=True,
        verbose_name=_('title'),
    )
    priority = models.IntegerField(
        default=0,
        verbose_name=_('priority'),
    )
    short_description = models.CharField(
        max_length=255,
        blank=True,
        null=True,
        verbose_name=_('short description'),
        help_text=_('A few words, shown in categories list'),
    )
    full_description = models.TextField(
        blank=True,
        null=True,
        verbose_name=_('full description'),
        help_text=_('Shown in category detail view'),
    )

    class Meta:
        ordering = ('priority',)
        verbose_name = _('topic category')
        verbose_name_plural = _('topic categories')
        permissions = [
            (
                'view_topiccategory_metadata',
                _('Can view topic category metadata'),
            ),
        ]

    def __str__(self):
        return self.title

    @property
    def topics_count(self):
        """Return the count of topics linked to this category"""
        return self.topics_set.count()

    @property
    def replies_count(self):
        """Return the count of replies in this category"""
        return sum(
            [
                topic.replies_count
                for topic
                in self.topics_set.all()
            ]
        )

    @property
    def messages_count(self):
        """Return the count of all messages in this category

        Note: Each topic and each reply have 1 message
        """
        return self.topics_count + self.replies_count

    @property
    def latest_topic(self):
        """Return the latest topic in this category"""
        if self.topics_set.exists():
            return self.topics_set.latest('created_on')
        else:
            return None
        
    @property
    def latest_reply(self):
        """Return the latest reply in this category"""
        if self.topics_set.exists():
            # Get latest reply of each topics
            topics_latest_replies = [
                topic.latest_reply
                for topic
                in self.topics_set.all()
                if topic.latest_reply is not None
            ]

            # If get no latest replies, return None
            if len(topics_latest_replies) == 0:
                return None

            # Sort the messages
            sorted_topic_replies = sorted(
                topics_latest_replies,
                key=lambda reply: reply.created_on,
                reverse=True,
            )
            return sorted_topic_replies[0]
        else:
            return None

    @property
    def latest_message_created_on(self):
        """Return the latest message created_on value

        Note: Each topic and each reply have 1 message
        """
        # Get latest topic and reply
        latest_topic = self.latest_topic
        latest_reply = self.latest_reply

        if latest_topic and not latest_reply:
            return latest_topic.created_on

        if latest_reply and not latest_topic:
            return latest_reply.created_on

        if not latest_reply and not latest_topic:
            return None

        if latest_topic.created_on > latest_reply.created_on:
            return latest_topic.created_on

        return latest_reply.created_on

    def get_absolute_url(self):
        """Get the absolute URL of a model instance"""
        return reverse(
            'slow_forum:topic-category-details',
            kwargs={'pk': self.pk},
        )


class Topic(FormatedMessage, EditableModel):
    """A topic, to talk"""
    created_by = models.ForeignKey(
        settings.AUTH_USER_MODEL,
        on_delete=models.CASCADE,
        verbose_name=_('created_by'),
    )
    created_on = models.DateTimeField(
        default=timezone.now,
        verbose_name=_('created_on'),
    )
    subject = models.CharField(
        max_length=255,
        verbose_name=_('subject'),
    )

slow_forum/forms.py
from django.utils.translation import gettext_lazy as _
from django.forms import (
    inlineformset_factory,
    ModelForm,
    Form,
    HiddenInput,
    TextInput,
    Textarea,
    NumberInput,
    URLInput,
    Select,
    PasswordInput,
    CharField,
)
from django.contrib.auth import password_validation
from django.contrib.auth.forms import (
    AuthenticationForm,
    UsernameField,
    PasswordChangeForm,
)

import shlex

from slow_forum.models import (
    Topic,
    TopicReply,
    TopicCategory,
    UserProfile,
    UserProfileExternalLinks,
)


# Forms for slow_forum

class TopicReplyForm(ModelForm):
    """A model form for TopicReply"""
    
    class Meta:
        model = TopicReply
        fields = ('message',)


class SearchForm(Form):
    """A simple search form"""
    q = CharField(
        label=_('Query'),
        max_length=255,
        required=False,
    )

    def get_search_query_splited(self):
        """Return the search query, splitted"""
        if self.is_valid():
            return shlex.split(
                self.cleaned_data['q'],
            )
        else:
            return []
            

slow_forum/templates/slow_forum/base.html
{% load i18n static %}
{% get_current_language as language_code%}
<!DOCTYPE HTML>
<html lang="{{ language_code }}">
    <head>
        <title>
            {{ global_preferences.general__forum_name|escape }}: {% block page_title%}{% endblock %}
        </title>

        {% if global_preferences.general__forum_favicon %}
            <link rel="icon" href="/media/{{ global_preferences.general__forum_favicon }}">
        {% endif %}
        
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta charset="UTF-8"/>
        <link href="{% static 'slow_forum/bootstrap-5.3.0-dist/css/bootstrap.min.css' %}" rel="stylesheet">
        <link href="{% static 'slow_forum/bootstrap-icons-1.10.5/font/bootstrap-icons.css' %}" rel="stylesheet">
        <link href="{% static 'slow_forum/pygment/styles.css' %}" rel="stylesheet">
        <link rel="stylesheet" href="{% static 'slow_forum/forum/style_screen.css' %}" type="text/css" media="screen" />
    </head>
    <body>
        <header class="border-bottom mb-5">
            <nav class="main_nav navbar navbar-expand-sm bg-body-tertiary">
                <div class="container-fluid">
                    <a class="navbar-brand" title="{% translate "Click to go back at forum root" %}" href="/">
                        {% if global_preferences.general__forum_logo %}
                            <img class="forum_logo d-inline-block align-text-top" alt="logo" src="/media/{{ global_preferences.general__forum_logo }}"/>
                        {% endif %}
                        {{ global_preferences.general__forum_name|escape }}
                    </a>
                    <ul class="navbar-nav mb-2 mb-lg-0" aria-description="{% translate "Main navigation" %}">
                        <li class="nav-item mx-2">
                            <a href="{% url 'slow_forum:index' %}" class="nav-link">{% translate "Home" %}</a>
                        </li>
                        <li class="nav-item mx-2">
                            <a class="nav-link" href="{% url 'slow_forum:topic-category-list' %}">{% translate "Categories" %}</a>
                        </li>
                        <li class="nav-item mx-2">
                            <a href="{% url 'slow_forum:user-profile-list' %}" class="nav-link">{% translate "Profiles" %}</a>
                        </li>
                        <li class="nav-item mx-2">
                            <a href="{% url 'slow_forum:about' %}" class="nav-link">{% translate "About" %}</a>
                        </li>

                        {# Feeds entry #}
                        
                        <li class="nav-item mx-2">
                            <a class="nav-link" href="{% url 'slow_forum:feeds' %}" title="{% translate "Feeds" %}">
                                <i class="bi bi-rss-fill"></i>
                            </a>
                        </li>

                        {# More menu #}
                        
                        {% if user.is_staff %}
                            
                            <li class="nav-item mx-2">
                                <div class="dropdown">
                                    <button class="btn btn-outline-secondary dropdown-toggle" type="button" data-bs-toggle="dropdown" aria-expanded="false">
                                        {% translate "More" %}
                                    </button>

                                    <ul class="dropdown-menu dropdown-menu-end" role="menu" aria-description="{% translate "Menu more, in main navigation menu" %}">
                                        
                                        {% if user.is_staff %}
                                            <li>
                                                <a class="dropdown-item" href="{% url 'admin:index' %}">{% translate "Administration" %}</a>
                                            </li>
                                        {% endif %}
                                        
                                    </ul>
                                    
                                </div>
                            </li>

                        {% endif %}

                        {# Account menu #}

                        {% if user.is_authenticated %}

                            <li class="nav-item mx-2">
                                <div class="dropdown">
                                    <button class="btn btn-outline-secondary dropdown-toggle" type="button" data-bs-toggle="dropdown" aria-expanded="false">
                                        {% translate "Account" %}
                                    </button>

                                    <ul class="dropdown-menu dropdown-menu-end" role="menu" aria-description="{% translate "Menu more, in main navigation menu" %}">
                                        
                                        <li>
                                            <a class="dropdown-item" href="{{ user.profile.get_absolute_url }}">
                                                {% translate "My profile" %}
                                            </a>
                                        </li>
                                        
                                        <li>
                                            <a class="dropdown-item" href="{% url 'password_change' %}">
                                                {% translate "Password change" %}
                                            </a>
                                        </li>

                                        <li>
                                            <a class="dropdown-item" href="{% url 'logout' %}">
                                                {% translate "Logout" %}
                                            </a>
                                        </li>
                                        
                                    </ul>
                                    
                                </div>
                            </li>
                            
                        {% else %}

                            <li>
                                <a class="nav-item mx-2 btn btn-outline-secondary" href="{% url 'django_registration_register' %}">
                                    {% translate "Create account" %}
                                </a>
                            </li>
                            
                            <li>
                                <a class="nav-item mx-2 btn btn-outline-secondary" href="{% url 'login' %}">
                                    {% translate "Login" %}
                                </a>
                            </li>
                            
                        {% endif %}

                    </ul>
                </div>
            </nav>
        </header>
        <main class="content container">
            {% block main %}{% endblock %}
        </main>
        <footer>
            <div class="container mt-5">
                {% block footer %}
                    <div class="border-top text-body-secondary">
                        {% translate "Made with" %} <a href="https://framagit.org/swisslinux.org/slow_forum">
                        Slow Forum
                        </a>, {% translate "a Free Software under the licence" %} <a href="https://www.gnu.org/licenses/gpl-3.0.fr.html">
                            {% translate "GPLv3 or later" %}
                        </a>
                    </div>
                {% endblock %}
            </div>
        </footer>
        <script src="{% static 'slow_forum/bootstrap-5.3.0-dist/js/bootstrap.bundle.min.js' %}"></script>
    </body>
</html>

slow_forum/templates/slow_forum/feeds.html
{% extends "slow_forum/base_content.html"%}
{% load i18n tz slow_promote %}

{% block page_title %}
    {% translate "All feeds" %}
{% endblock %}

{% block content_title %}
    {% translate "All feeds" %}
{% endblock %}

{% block content %}

    <div class="feeds_page vstack gap-5">
        
        {# Page description #}

        <div class="page_description">
            <p>
                {% blocktranslate %}
                You can found bellow all the Atom feeds of this forum.
                {% endblocktranslate %}
            </p>
        </div>

        {# Main feeds #}

        <div class="main_feeds vstack gap-2">

            <h2 class="text-secondary">
                {% translate "Main feeds" %}
            </h2>

            <ul>
                <li>
                    <a class="icon-link" href="{{ feeds.topics_all.url }}">
                        <i class="bi bi-rss-fill"></i>
                        {{ feeds.topics_all.verbose_name }}
                    </a>
                </li>
                <li>
                    <a class="icon-link" href="{{ feeds.topic_replies_all.url }}">
                        <i class="bi bi-rss-fill"></i>
                        {{ feeds.topic_replies_all.verbose_name }}
                    </a>
                </li>
            </ul>
            
        </div>

        {# Categories feeds #}

        <div class="categries_feeds vstack gap-2">

            <h2 class="text-secondary">
                {% translate "Categories feeds" %}
            </h2>

            <table class="table">
                <thead>
                    <tr>
                        <th scope="col">
                            {% translate "Category" %}
                        </th>
                        <th scope="col">
                            {% translate "Topics feed" %}
                        </th>
                        <th scope="col">
                            {% translate "Topic replies feed" %}
                        </th>
                    </tr>
                </thead>
                <tbody>
                    {% for category in categories %}
                        <tr>

                            {# Category #}
                            
                            <td>
                                {{ category.title|escape }}
                            </td>
                            
                            {# Topics feed #}
                            
                            <td>
                                <a class="icon-link" href="{% url 'slow_forum:feed-topics-category' category_pk=category.pk %}">
                                    <i class="bi bi-rss-fill"></i>
                                </a>
                            </td>
                            
                            {# Topic replies feed #}
                            
                            <td>
                                <a class="icon-link" href="{% url 'slow_forum:feed-topic-replies-category' category_pk=category.pk %}">
                                    <i class="bi bi-rss-fill"></i>
                                </a>
                            </td>
                        </tr>
                    {% endfor %}
                </tbody>
            </table>

        </div>
        
    </div>    
    
{% endblock %}

slow_forum/templates/slow_forum/nothing_here.html
{% load i18n tz %}

<div class="nothing_here">

    <h1>{% translate "There is nothing here" %}</h1>

    <p>{% blocktrans %}If you are here, that mean your are lost.{% endblocktrans %}</p>

     <a href="{% url 'slow_forum:index' %}">Return to index</a>

</div>

slow_forum/templates/slow_forum/topic_detail.html
{% extends "slow_forum/base_content.html"%}
{% load i18n tz slow_forms slow_message %}

{% block page_title %}{{ topic.subject|escape }}{% endblock %}

{% block breadcrumb %}
    <li class="breadcrumb-item">
        <a href="{% url 'slow_forum:topic-category-list' %}">
            {% translate "Topics categories" %}
        </a>
    </li>
    <li class="breadcrumb-item">
        <a href="{{ topic.category.get_absolute_url }}">
            {{ topic.category.title|escape }}
        </a>
    </li>
{% endblock %}

{% block content_title %}{{ topic.subject|escape }}{% endblock %}

{% block content_actions %}
    
    {% if perms.slow_forum.change_topic or topic.created_by == user %}
        <li class="nav-item ms-3">
            <a class="btn btn-outline-secondary my-auto" href="{% url 'slow_forum:topic-update' pk=topic.pk %}">{% translate "Edit" %}</a>
        </li>
    {% endif %}
    
    {% if perms.slow_forum.delete_topic %}
        <li class="nav-item ms-3">
            <a class="btn btn-outline-danger my-auto" href="{% url 'slow_forum:topic-delete' pk=topic.pk %}">{% translate "Delete" %}</a>
        </li>
    {% endif %}
{% endblock %}

{% block content %}
    <div class="topic vstack gap-5">

        {% topic_message topic %}

        <div class="replies_list" aria-description="{% translate "Replies list" %}">

            <h2 class="">
                {% if topic.replies_count == 0 %}
                    {% translate "Replies" %}
                {% elif topic.replies_count == 1 %}
                    {{ topic.replies_count }} {% translate "reply" %}
                {% else %}
                    {{ topic.replies_count }} {% translate "replies" %}
                {% endif %}
            </h2>
            
            {% for reply in topic.replies_set.all %}
                
                {% topic_reply_message reply %}

            {% empty %}

                <div class="no_reply mb-4">
                    <p>{% translate "No reply for now" %}</p>
                </div>
                
            {% endfor %}

        </div>

        <div class="reply_add">
            <h2>{% translate "Reply to this topic" %}</h2>
            {% if not user.is_anonymous %}
                {% if perms.slow_forum.add_topicreply %}
                    <form action="{% url 'slow_forum:topic-reply-add' topic_pk=topic.id %}" method="post">
                        {% csrf_token %}
                        {% bootstrap_form topic_reply_form %}
                        <input type="submit" class="btn btn-primary" value="{% translate "Reply" %}" />
                    </form>
                {% else %}
                    <p>{% translate "You need to have the permission to reply" %}</p>
                {% endif %}
            {% else %}
                <p>{% translate "You need to be logged to reply" %}</p>
            {% endif %}
        </div>

        <div class="secondary_actions">
            <a class="icon-link link-secondary" href="{% url 'slow_forum:feed-topic-replies-topic' topic_pk=topic.pk %}" title="{% translate "Feed with replies of this topic" %}">
                <i class="bi bi-rss-fill"></i> {% translate "Follow replies by feed" %}
            </a>
        </div>

    </div>
{% endblock %}

slow_forum/templates/slow_forum/topic_reply_confirm_delete.html
{% extends "slow_forum/base_content.html"%}
{% load i18n tz %}

{% block page_title %}{% translate "Delete reply" %}{% endblock %}

{% block breadcrumb %}
    <li class="breadcrumb-item">
        <a href="{% url 'slow_forum:topic-category-list' %}">
            {% translate "Topics categories" %}
        </a>
    </li>
    
    <li class="breadcrumb-item">
        <a href="{{ topicreply.topic.category.get_absolute_url }}">
            {{ topicreply.topic.category.title|escape }}
        </a>
    </li>

    <li class="breadcrumb-item">
        <a href="{{ topicreply.topic.get_absolute_url }}">{{ topicreply.topic.subject }}</a>
    </li>

    <li class="breadcrumb-item">
        <a href="{{ topicreply.get_absolute_url }}">
            {% translate "Reply" %}
        </a>
    </li>
    
{% endblock %}

{% block content_title %}
    {% translate "Delete reply" %}
{% endblock %}

{% block content %}
    <form method="post">
        {% csrf_token %}
        <p>
            {% blocktranslate with topic_subject=topicreply.topic.subject|escape topicreply_created_by=topicreply.created_by.profile.nickname|escape %}
            Are you sure you want to delete the reply of {{ topicreply_created_by }} on the topic "{{ topic_subject }}" ?
            {% endblocktranslate %}
        </p>
        {{ form }}
        <input class="btn btn-danger" type="submit" value="{% translate "Confirm" %}" />
    </form>
    
{% endblock %}